/*
 * Display
 */

#ifndef __display_h__
#define __display_h__

#include "types.h"
#include "io.h"

#include <time.h>

struct _display {
	time_t start_time;
	time_t total_time;
	time_t current_time;
	time_t elapsed_time;
	float percent_complete;
	int display_interval;
	int overtime_flag;
	unsigned int k;
	char twiddle;
	int screen_width;
	int manual_width;
	int screen_width_minus_one;
	int display_twiddle;
	int display_datacount;
	int display_throughput;
	int display_time;
	int display_percent;
	int display_bar;
	int display_summary;
};

typedef struct _display display;

extern display d;

int displayInit(void);
int displayBegin(void);
int displayUpdate(void);
int displayEnd(void);

#endif
