/*
 * I/O and buffering
 */

#ifndef __io_h__
#define __io_h__

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif
#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif
/*
#include <time.h>
*/

#include "types.h"

/*
#define STAT_DATA_SIZE 1024
*/

struct _io {
	int in;
	int out;
	int in_ready;
	int out_ready;
	int eof_in;
	int eof_out;
	size_t buffer_size;
	char *buffer;
	int watermark;
	ssize_t last_read;
	ssize_t last_write;
	uint64 total_read;
	uint64 total_write;
	uint64 total_size;
	int total_size_known;
	uint32 timeout;

	/* Statistics */
	/*
	uint64 stat_data[STAT_DATA_SIZE];
	int num_data;
	int stat_ptr;
	time_t stat_timestamp;
	*/
	};

typedef struct _io IO;

extern IO io;

int ioInit(void);
int ioBegin(void);
int ioEnd(void);
void ioCheck(void);
int ioRead(void);
int ioWrite(void);
int ioIsDone(void);

#endif
